/*
    $Id: BinarySemaphore.java,v 1.1 1997/07/23 17:59:17 augusto Exp $

    Copyright (C) 1997  Augusto Ciuffoletti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact address: augusto@di.unipi.it

    $Log: BinarySemaphore.java,v $
    Revision 1.1  1997/07/23 17:59:17  augusto
    Initial revision

*/
package syd.binarysemaphore;

/*

The BinarySemaphore is a semaphore that allows the exchange of a simple
binary data. The p() is initially blocked, and the other partner can call
either a v() or a x(). In the first case the will unblock with a "true"
result passed to the caller. In the latter the p() will return a "false"
value.

*/

public class BinarySemaphore {
  protected boolean terminate = false;
  protected boolean available = false;
  public synchronized boolean p() throws InterruptedException {
    while (available == false) wait();
    available = false;
    notifyAll();
    return terminate;
  };
  public synchronized void v() throws InterruptedException {
    while (available == true) wait();
    available = true;
    terminate = true;
    notifyAll();
  };
  public synchronized void x() throws InterruptedException {
    while (available == true) wait();
    available = true;
    terminate = false;
    notifyAll();
    return;
  };
}
