/*
    $Id: Tester.java,v 1.1 1997/07/23 17:59:21 augusto Exp $

    Copyright (C) 1997  Augusto Ciuffoletti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact address: augusto@di.unipi.it

    $Log: Tester.java,v $
    Revision 1.1  1997/07/23 17:59:21  augusto
    Initial revision

*/
import binarysemaphore.*;

class Tester {
   public static void main (String[] args) throws InterruptedException {
      PallaT p,q;
      BinarySemaphore semp, semq;
      semp = new BinarySemaphore();
      p = new PallaT(semp);
      p.start();
      semq = new BinarySemaphore();
      q = new PallaT(semq,"rossa");
      q.start();
      System.out.println("Eccomi qua!"); // Stampa una frasetta
      semp.v();
      System.out.println("+ default"); // Avanzamento
      semp.v();
      System.out.println("+ default"); // Avanzamento
      semq.v();
      System.out.println("+ rossa"); // Avanzamento
      semp.x();
      System.out.println("- default"); // Avanzamento
      semq.x();
      System.out.println("- rossa"); // Avanzamento
      semp.x();
      System.out.println("- default"); // Avanzamento
      semq.x();
      System.out.println("- rossa"); // Avanzamento
      semq.v();
      System.out.println("+ rossa"); // Avanzamento
      return;
     }
  }
class PallaT extends Thread{
  private BinarySemaphore semaforo;
  private boolean term = false;
  private int contenuto = 0;
  private String nome;

  PallaT(BinarySemaphore sem) {
    this.semaforo=sem;
    this.nome = "palla-default";
  }  
  PallaT(BinarySemaphore sem, String s) {
    this.semaforo=sem;
    this.nome = "palla-" + s;
  }
  public void run () {
    int i;
    try {
      for (i=1; i<5; i++) {
        term=semaforo.p();
        if (term == false)
           this.contenuto--;
        else
           this.contenuto++;
        System.out.println("Touche':" + nome + " " + contenuto);
        try { 
          this.sleep(1000); 
        } catch (InterruptedException e) {
          System.out.println("Arrgh");
        }
      } 
    } catch (InterruptedException e) {}
    System.out.println("Valore di " + this.nome + " = " + this.contenuto);
    return;  
  }
}
