/*
    $Id: SystemClock.java,v 1.1 1997/07/23 18:36:43 augusto Exp $

    Copyright (C) 1997  Augusto Ciuffoletti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact address: augusto@di.unipi.it

    $Log: SystemClock.java,v $
    Revision 1.1  1997/07/23 18:36:43  augusto
    Initial revision

*/
package syd.logicalclock;

/**
 * Represents the local system clock
 *
 * @version $Id: SystemClock.java,v 1.1 1997/07/23 18:36:43 augusto Exp $
 * @author Augusto Ciuffoletti
 *
 */
public class SystemClock{
  /**
   * ACCESSOR: it is a static method that returns the current time, in
   * millisecs. It can be implemented as a native method, or using
   * the <code>System.currentTimeMillis</code> method.
   *
   * @returns the current time in millisecs as a long
   */
  static public long read(){
    return System.currentTimeMillis();
  }
}
