/*
    $Id: EmitterStates.java,v 1.1 1997/07/23 18:37:06 augusto Exp $

    Copyright (C) 1997  Augusto Ciuffoletti

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Contact address: augusto@di.unipi.it

    $Log: EmitterStates.java,v $
    Revision 1.1  1997/07/23 18:37:06  augusto
    Initial revision

*/
package syd.mpx;
/**
 *
 * @version $Id: EmitterStates.java,v 1.1 1997/07/23 18:37:06 augusto Exp $
 * @author Augusto Ciuffoletti
 *
 */
class EmitterStates
{
  private boolean[] pending;
  private boolean[] alive;
  private static int how_many;

  public EmitterStates(int n) {
    int i;

    how_many=n;
    pending = new boolean[how_many];
    alive = new boolean[how_many];
    for (i=0;i<how_many;i++) {
      pending[i] = false;
      alive[i] = false;
    }
    return;
  }
  public boolean set_pending(int x) {
    pending[x] = true;
    return true;
  }
  public boolean reset_pending(int x) {
    pending[x] = false;
    return true;
  }
  public boolean is_pending(int x) {
    return pending[x];
  }
  public boolean no_pending() {
    int i;
    for (i=0; i<how_many; i++)
      if (pending[i] == true) return false;
    return true;
  }
  public int next_pending() {
    int i;
    for (i=0; i<how_many; i++)
      if (pending[i] == true) return i;
    return -1;
  }
  public boolean set_alive(int x) {
    alive[x] = true;
    return true;
  }
  public boolean reset_alive(int x) {
    alive[x] = false;
    return true;
  }
  public boolean is_alive(int x) {
    return alive[x];
  }
  public boolean no_alive() {
    int i;
    for (i=0; i<how_many; i++)
      if (alive[i] == true) return false;
    return true;
  }
}
