package syd.session;

import syd.session.*;
import syd.inputdata.*;
import syd.logicalclock.*;

class SessionTest extends Session {
  static long dummy_sleep[] = new long[6];
  static boolean dummy_retcode[] = new boolean[6];
  static long dummy_precision[] = new long[6];
  static int i=0;
  static long baseline;

  public SessionTest() {
    identity = 0;
    sd = new InputData();
    sd.delta_max = 100;
    sd.rho = 1000;
    sd.k=4;
    sd.w=10000;
    sd.epsilon=10;
    lc = new LogicalClock(sd.rho);
    baseline = SystemClock.read();
    return;
  }  
  boolean retry() {
    System.out.println("Retrying at time " + (SystemClock.read()-baseline));
    System.out.println("Retry lasts " + dummy_sleep[i]);
    System.out.println(" and returns " + dummy_retcode[i]);
    System.out.println(" with precision " + dummy_precision[i]);
    try {Thread.sleep(dummy_sleep[i]);} catch (InterruptedException e) {}
    if (dummy_precision[i] > 0) {
      LogicalTime lt = new LogicalTime(123456,dummy_precision[i]);
      lc.setLogicalClock(lt);
    }
    System.out.println("Retry completed at time " + (SystemClock.read()-baseline));
    return dummy_retcode[i++];
  }
} 
class Testerb3 {
  static SessionTest sx;
  static String[] presentation ={
"This test runs one attempt that does not succed to reach contact,",
"but that nevertheless succeeds in delivering an acceptable clock.",
"The test checks the -best effort- behavior, since the attempt",
"should terminate successfully even if the session does not reach",
"contact with the remote clock",
"The second attempt is successful at the first retry"};

  public static void main(String[] args) {
    int i;
    for (i=0;i<presentation.length;i++)
      System.out.println(presentation[i]);
    System.out.println("Testing the attempt method");
    sx = new SessionTest();
/* first */
    sx.dummy_sleep[0]=2000;
    sx.dummy_precision[0]=50;
    sx.dummy_retcode[0]=true;
/* second */
/* timeout */
    sx.dummy_sleep[1]=10000;
    sx.dummy_precision[1]=0;
    sx.dummy_retcode[1]=false;
/* third */
    sx.dummy_sleep[2]=4000;
    sx.dummy_precision[2]=100; 
    sx.dummy_retcode[2]=true;
/* fourth */
    sx.dummy_sleep[3]=5000;
    sx.dummy_precision[3]=50;
    sx.dummy_retcode[3]=true;
/* fifth */
    sx.dummy_sleep[4]=6000;
    sx.dummy_precision[4]=5;
    sx.dummy_retcode[4]=true;
    try { 
      System.out.println("========== First attempt");
      sx.attempt(); 
    } catch (FailureException e) {
      System.out.println("1st attempt failed: "+e.why);
    } 
    try {
      System.out.println("========== Second attempt");
      sx.attempt(); 
    } catch (FailureException e) {
      System.out.println("2nd attempt failed: "+e.why);
    } 
  }
}
