package syd.session.test;

import syd.session.*;
import syd.inputdata.*;
import syd.logicalclock.*;
import syd.binarysemaphore.*;
import syd.remoteclock.*;
import syd.session.test.*;
import syd.mpx.*;

class Daemon {
  private static SessionTest[] session = new SessionTest[1];
  private static Mpx channel;
  private static BinarySemaphore[] binsem = new BinarySemaphore[1];
  private static InputData[] session_description = new InputData[1];
  private static RemoteClockTest remote_clock;

  public static void main(String argv[]) {
    session_description[0] = new InputData();
    session_description[0].delta_max = 150;
    session_description[0].rho = 200;
    session_description[0].k=4;
    session_description[0].w=10000;
    session_description[0].epsilon=50;
    channel = new Mpx(1);
    binsem[0] = new BinarySemaphore();
    remote_clock = new RemoteClockTest(session_description[0]);
    session[0] = new SessionTest(0,session_description[0],channel,binsem[0],remote_clock);
    try {
      session[0].start();
      channel.mpx_accept(0);
    } catch ( InterruptedException e) {
      System.out.println("InterruptedException while starting session");
      return;
    }
    try {
      while ( channel.mpx_select() >= 0) {
        System.out.println("*** Daemon selects session");
        binsem[0].v();
      }
    } catch (InterruptedException e) {
      System.out.println("InterrupedException during select");
      return;
    }
  }
}

class SessionTest extends syd.session.Session {
  public SessionTest(int id, InputData ses_descr, Mpx c, BinarySemaphore bs, RemoteClock rc){
    super(id,ses_descr,c,bs,rc);
  }
  public void verbose(String s) {System.out.println(s);}
}
