package syd.test;

import syd.logicalclock.*;

class Testlogicalclock {
  static long t1,t2,t3;
  static LogicalClock lc1,lc2,lc3;

  public static void main(String argv[]) 
   throws LogicalClockException {
    int i,j,k;
    lc1 = new LogicalClock(1000);
    t1 = SystemClock.read();
    lc1.set(t1-500,0);    
    System.out.println("Testing encoding and decoding functions...");
    byte[] data = lc1.toBytes();
    lc3 = new LogicalClock(data);
    byte[] data2 = lc3.toBytes();
    System.out.println(lc1.toString());
    System.out.println(lc3.toString());
/*    for (i=0;i<40;i++) System.out.println(i+" "+data[i]+" "+data2[i]); */
/* Valutazione del tempo di esecuzione della get */
    t1 = SystemClock.read();
    lc1.set(t1+500,0);    
    System.out.println("Profiling method precision()...");
    t2 = SystemClock.read();
    for (i=0;i<1000;i++) {
      try { t1=lc1.precision(); } catch (LogicalClockException e) {}
    }
    t3 = SystemClock.read();
    System.out.println("1000 getLogicalClock in "+ (t3-t2) + " msecs");
/* Valutazione del tempo di esecuzione della set (con displacement) */
    System.out.println("Profiling setLogicalClock...");
    t2 = SystemClock.read();
    for (i=0;i<1000;i++) {
      t1 = SystemClock.read();
      lc1.set(t1+500,30,t1-2000);    
    }
    t3 = SystemClock.read();
    System.out.println("1000 setLogicalClock in "+ (t3-t2) + " msecs");
/* test di set e get senza displacement (when) */
    System.out.println("Testing get and setLogicalClock without when...");
    lc1 = new LogicalClock(1000);
    t1 = SystemClock.read();
    lc1.set(t1+500,10);
    try { Thread.sleep(10000); } catch (InterruptedException e) {}
    t2 = SystemClock.read();
    System.out.println("Check: " + t2 + "+500 = " + lc1.value());
    System.out.println("Check: 20 = " + lc1.precision());
/* test di set con displacement (when) */
    System.out.println("Testing setLogicalClock with when...");
    lc2 = new LogicalClock(1000);
    lc2.set(t1+500,10,t1);
    try { Thread.sleep(10000); } catch (InterruptedException e) {}
    t3 = SystemClock.read();
    System.out.println("Check: " + t3 + "+500 = " + lc2.value());
    System.out.println("Check: 30 = " + lc2.precision());
/* test di get con displacement (when) */
    System.out.println("Testing getLogicalClock with when...");
    System.out.println("Check: " + t1 + "+500 = " + lc2.value(t1));
    System.out.println("Check: 10 = " + lc2.precision(t1));
/* test delle funzioni di codifica-decodifica */
    return;    
  }
}




