package syd.test;

import syd.logicalclock.*;
import syd.remoteclock.*;
import syd.inputdata.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class Testremoteclock {
  private static RemoteClock rc; 
  private static NTPTime nt1, nt2;
  private static long t1,t2;
  private static byte[] b1, b2;
  private static InputData sd;
  private static String address="127.0.0.1";
  private static int port=1200;

  public static void main(String[] args) 
         throws LogicalClockException {
    int i;

    System.out.println("Now testing at random the NTPTime class: ");
    System.out.println("the following lines should be identical.");
    t1 = SystemClock.read();
    System.out.println(new Date(t1) + " " + (t1 % 1000));
    nt1 = new NTPTime(t1);
    b1 = nt1.toBytes();
    nt2 = new NTPTime(b1);
    t2 = nt2.toLong();
    System.out.println(new Date(t2) + " " + (t2 % 1000));
    System.out.println(" =================================== ");

    System.out.println("Now carpet testing the NTPTime class: ");
    System.out.println("errors are counted.");
    int j = 0;
    for (i=0;i<1000000;i++)
      {
	t1 = i;
	nt1 = new NTPTime(t1);
	b1 = nt1.toBytes();
	nt2 = new NTPTime(b1);
	t2 = nt2.toLong();
        if ( t1 != t2 ) j++;
      }    
    System.out.println("Errors = "+j);

    if ( args.length > 0 ) {
      address = args[0];
      port = Integer.valueOf(args[1]).intValue() ;
    }
    System.out.println("Now testing the NTP protocol (class RemoteClock) by ");
    System.out.println("executing the -read- method. Host address is "+address);
    System.out.println("This method accepts two command line parameter to ");
    System.out.println("override the default address and port");
    sd = new InputData(0);
    LogicalClock lc = new LogicalClock(0);
    sd.host=address;
    sd.port=port;
    rc=new RemoteClock(sd);
    try {
      rc.read(SystemClock.read(),lc);
    } catch ( IOException e ) {
      e.printStackTrace();
      return;
    }
    System.out.println("t0: " + new Date(rc.t0()) + " " + (rc.t0() % 1000));
    System.out.println("tr: " + new Date(rc.tr()) + " " + (rc.tr() % 1000));
    System.out.println("tt: " + new Date(rc.tx()) + " " + (rc.tx() % 1000));
    System.out.println("t1: " + new Date(rc.t1()) + " " + (rc.t1() % 1000));
    System.out.println("Roundtrip is: " + (rc.t1() - rc.t0()) + " msecs");   
    System.out.println(" =================================== ");
  }
}
