package syd.test;

import syd.session.*;
import syd.inputdata.*;
import syd.logicalclock.*;
import syd.binarysemaphore.*;
import syd.remoteclock.*;
import syd.mpx.*;
import syd.log.*;

public class Testsession {
  public static void main(String[] args) {
    if (args.length != 2) 
    {
      System.err.println("Usage: Testsession <host> <port>");
      return;
    }
  Daemon.main(args);
  }
}

class Daemon {
  private static SessionTest[] session = new SessionTest[1];
  private static Mpx channel;
  private static InputData[] session_description = new InputData[1];
  private static LogicalClock logical_clock;

  public static void main(String args[]) {
    session_description[0] = new InputData(0);
    session_description[0].host=args[0];
    session_description[0].port=Integer.valueOf(args[1]).intValue();
    session_description[0].delta_max = 150;
    session_description[0].rho = 200;
    session_description[0].k=4;
    session_description[0].w=10000;
    session_description[0].epsilon=50;
    session_description[0].verbose=true;
    channel = new Mpx(1);
    logical_clock = new LogicalClock(session_description[0].rho);
    session[0] = new SessionTest(session_description[0],channel,logical_clock);
    try {
      session[0].start();
      channel.mpx_accept(0);
    } catch ( InterruptedException e) {
      System.out.println("InterruptedException while starting session");
      return;
    }
    try {
      while ( channel.mpx_select() >= 0) {
        System.out.println("*** Daemon selects session");
      }
    } catch (InterruptedException e) {
      System.out.println("InterrupedException during select");
      return;
    }
  }
}

class SessionTest extends syd.session.Session {
  public SessionTest(InputData ses_descr, Mpx c, LogicalClock lc) {
    super(ses_descr,c,lc);
  }
  public void verbose(String s) {System.out.println(s);}
}
